﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.47
@EndOfDesignText@
Sub Class_Globals
	Public bw As X2BodyWrapper
	Private x2 As X2Utils 'ignore
	Dim impulsValue As Float = 20
	Dim FallGravityScale As Float = 1.4
	Dim HighJumpGravityScale As Float = 0.5
	Private ApplyForce As Boolean
End Sub

Public Sub Initialize (wrapper As X2BodyWrapper)
	bw = wrapper
	x2 = bw.X2
End Sub

'Public Sub Tick2 (GS As X2GameStep)
'	
'	' push the ball if pressed	
'	If x2.mGame.Jump = True Then
'		x2.mGame.Jump = False 
'		bw.Body.ApplyLinearImpulse(x2.CreateVec2(0, impulsValue), bw.Body.Position)
'		x2.SoundPool.PlaySound("wing")
'	End If
'	'
'	' ******************************************************************
'	' *  Modify the BodyGravity for nicer Jumps                        *
'	' *                                                                *
'	' *  1) jump upwards and downwards have different Gravity settings *
'	' *  2) shot press done with normal Gravity = normal jumps         *
'	' *  3) long press done Gravity will be lower = higher jumps       *
'	' *                                                                *
'	' ******************************************************************
'	' 
'	'
''	If bw.Body.LinearVelocity.Y < 0 Then ' are in up- or down direction?
''		' body is in falling direction = raise of Gravity
''		bw.Body.GravityScale = FallGravityScale
''		x2.mGame.Up = True
''		'
''	Else if bw.Body.LinearVelocity.Y > 0 And (x2.mGame.Up = False) Then ' in up-direction and long pressing
''		' Gravity lower = higher Jump
''		bw.Body.GravityScale = HighJumpGravityScale
''	Else 
''		' non of all 
''		' Gravity normal = normal jump hight
''		bw.Body.GravityScale = 1
''	End If
'	'
''	Log (bw.Body.GravityScale)
'	'
'	If GS.ShouldDraw Then
'		bw.UpdateGraphic(GS, True)
'	End If
'	
'End Sub

Public Sub Tick (GS As X2GameStep)
   If x2.mGame.Jump = True And ApplyForce = False Then
       x2.mGame.Jump = False
       ApplyForce = True
       x2.AddFutureTask(Me, "Stop_Force", 100, Null)
       x2.SoundPool.PlaySound("wing")
   End If
   If ApplyForce Then
       bw.Body.ApplyForce(x2.CreateVec2(0, impulsValue), bw.Body.Position)
   End If

   If GS.ShouldDraw Then
       bw.UpdateGraphic(GS, True)
   End If
End Sub

Sub Stop_Force (ft As X2FutureTask)
   ApplyForce = False
End Sub